Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbDev.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbDev.rc	(revision 53604)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/dev/VBoxUsbDev.rc	(revision 53781)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2011-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,29 +22,29 @@
 
 VS_VERSION_INFO VERSIONINFO
-   FILEVERSION          VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   PRODUCTVERSION       VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   FILEFLAGSMASK        VS_FFI_FILEFLAGSMASK
-   FILEFLAGS            0x0L
-   FILEOS               VOS_NT_WINDOWS32
-   FILETYPE             VFT_DRV
-   FILESUBTYPE          VFT2_DRV_SYSTEM
+  FILEVERSION      VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+  PRODUCTVERSION   VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+  FILEFLAGSMASK    VS_FFI_FILEFLAGSMASK
+  FILEFLAGS        0x0L
+  FILEOS           VOS_NT_WINDOWS32
+  FILETYPE         VFT_DRV
+  FILESUBTYPE      VFT2_DRV_SYSTEM
 BEGIN
-   BLOCK "StringFileInfo"
-   BEGIN
-      BLOCK "040904b0"
-      BEGIN
-         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
-         VALUE "FileDescription",  "VirtualBox USB Driver\0"
-         VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
-         VALUE "InternalName",     "VBoxUSB.sys\0"
-         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
-         VALUE "OriginalFilename", "VBoxUSB.sys\0"
-         VALUE "ProductName",      VBOX_PRODUCT "\0"
-         VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
-      END
-   END
-   BLOCK "VarFileInfo"
-   BEGIN
-      VALUE "Translation", 0x409, 1200
-   END
+  BLOCK "StringFileInfo"
+  BEGIN
+    BLOCK "040904b0" // Lang=US English, CharSet=Unicode
+    BEGIN
+      VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
+      VALUE "FileDescription",  "VirtualBox USB Driver\0"
+      VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
+      VALUE "InternalName",     "VBoxUSB\0"
+      VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
+      VALUE "OriginalFilename", "VBoxUSB.sys\0"
+      VALUE "ProductName",      VBOX_PRODUCT "\0"
+      VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
+    END
+  END
+  BLOCK "VarFileInfo"
+  BEGIN
+    VALUE "Translation", 0x409, 1200
+  END
 END
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/mon/VBoxUsbMon.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/mon/VBoxUsbMon.rc	(revision 53604)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/mon/VBoxUsbMon.rc	(revision 53781)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011 Oracle Corporation
+ * Copyright (C) 2011-2015 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,29 +22,29 @@
 
 VS_VERSION_INFO VERSIONINFO
-   FILEVERSION          VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   PRODUCTVERSION       VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
-   FILEFLAGSMASK        VS_FFI_FILEFLAGSMASK
-   FILEFLAGS            0x0L
-   FILEOS               VOS_NT_WINDOWS32
-   FILETYPE             VFT_DRV
-   FILESUBTYPE          VFT2_DRV_SYSTEM
+  FILEVERSION      VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+  PRODUCTVERSION   VBOX_VERSION_MAJOR_NR,VBOX_VERSION_MINOR_NR,VBOX_VERSION_BUILD_NR,0
+  FILEFLAGSMASK    VS_FFI_FILEFLAGSMASK
+  FILEFLAGS        0x0L
+  FILEOS           VOS_NT_WINDOWS32
+  FILETYPE         VFT_DRV
+  FILESUBTYPE      VFT2_DRV_SYSTEM
 BEGIN
-   BLOCK "StringFileInfo"
-   BEGIN
-      BLOCK "040904b0"
-      BEGIN
-         VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
-         VALUE "FileDescription",  "VirtualBox USB Monitor Driver\0"
-         VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
-         VALUE "InternalName",     "VBoxUSBMon.sys\0"
-         VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
-         VALUE "OriginalFilename", "VBoxUSBMon.sys\0"
-         VALUE "ProductName",      VBOX_PRODUCT "\0"
-         VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
-      END
-   END
-   BLOCK "VarFileInfo"
-   BEGIN
-      VALUE "Translation", 0x409, 1200
-   END
+  BLOCK "StringFileInfo"
+  BEGIN
+    BLOCK "040904b0" // Lang=US English, CharSet=Unicode
+    BEGIN
+      VALUE "CompanyName",      VBOX_RC_COMPANY_NAME
+      VALUE "FileDescription",  "VirtualBox USB Monitor Driver\0"
+      VALUE "FileVersion",      VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD "." VBOX_SVN_REV "\0"
+      VALUE "InternalName",     "VBoxUSBMon\0"
+      VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
+      VALUE "OriginalFilename", "VBoxUSBMon.sys\0"
+      VALUE "ProductName",      VBOX_PRODUCT "\0"
+      VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
+    END
+  END
+  BLOCK "VarFileInfo"
+  BEGIN
+    VALUE "Translation", 0x409, 1200
+  END
 END